SoSelectOne(3)

NAME
SoSelectOne - The SoSelectOne class is used to select one value from a set of values.

SYNOPSIS

#include <Inventor/engines/SoSelectOne.h>

Inherits SoEngine.

  Public Member Functions
virtual SoType getTypeId (void) const
Returns the type identification of an object derived from a class inheriting SoBase. This is used for runtime type checking and 'downward' casting.
virtual const SoFieldData * getFieldData (void) const
virtual const SoEngineOutputData * getOutputData (void) const
SoSelectOne (SoType inputtype)

  Static Public Member Functions
static SoType getClassTypeId (void)
static void * createInstance (void)
static void initClass (void)
Sets up initialization for data common to all instances of this class, like submitting necessary information to the Coin type system.

  Public Attributes
SoSFInt32 index
SoMField * input
SoEngineOutput * output

  Static Protected Member Functions
static const SoFieldData ** getInputDataPtr (void)
static const SoEngineOutputData ** getOutputDataPtr (void)

  Additional Inherited Members

Detailed Description

The SoSelectOne class is used to select one value from a set of values. The output field will be the index'th value of the input multivalue field.

Note that this engine's output field deviates a little from the 'standard' output mechanism of the majority of engine classes: the SoSelectOne::output is not a permanent SoEngineOutput instance, but a pointer to a SoEngineOutput instance. The reason for this is that it is necessary to allocate the output field dynamically to make it match what the SoSelectOne::input is connected to since the type of the SoSelectOne::output always should be the same as the type of the SoSelectOne::input.

The file format for this field is a bit special. Note the leading type specification, which is not necessary for most other field types:

SelectOne {
  type <multivaluefieldtype>
  [...fields...]
}

Constructor & Destructor Documentation

  SoSelectOne::SoSelectOne (SoType inputtype)
Constructor. Sets the type of the input field. The input field must be of type SoMField.

Member Function Documentation

  virtual SoType SoSelectOne::getTypeId (void) const [virtual]

Returns the type identification of an object derived from a class inheriting SoBase. This is used for runtime type checking and 'downward' casting. Usage example:

void foo(SoNode * node)
{
  if (node->getTypeId() == SoFile::getClassTypeId()) {
    SoFile * filenode = (SoFile *)node;  // safe downward cast, knows the type
  }
}

For application programmers wanting to extend the library with new nodes, engines, nodekits, draggers or others: this method needs to be overridden in all subclasses. This is typically done as part of setting up the full type system for extension classes, which is usually accomplished by using the predefined macros available through for instance Inventor/nodes/SoSubNode.h (SO_NODE_INIT_CLASS and SO_NODE_CONSTRUCTOR for node classes), Inventor/engines/SoSubEngine.h (for engine classes) and so on.

For more information on writing Coin extensions, see the class documentation of the top level superclasses for the various class groups.

Implements SoBase.

  virtual const SoFieldData * SoSelectOne::getFieldData (void) const [virtual]
Returns a pointer to the class-wide field data storage object for this instance. If no fields are present, returns NULL.

Reimplemented from SoFieldContainer.

  virtual const SoEngineOutputData * SoSelectOne::getOutputData (void) const [virtual]
This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.

Implements SoEngine.

Member Data Documentation

  SoSFInt32 SoSelectOne::index
Index of the value from the input field which will be put on the output.

  SoMField * SoSelectOne::input
The multivalue input field which we will select a single value from for our output.

  SoEngineOutput * SoSelectOne::output
(SoSField) This is the singlevalue field output containing the index'th value of SoSelectOne::input.

The type of the field will of course match the type of the input field, i.e. if SoSelectOne::input is an SoMFFloat, SoSelectOne::output will be an SoSFFloat etc.

Author

Generated automatically by Doxygen for Coin from the source code.